﻿Add-PSSnapin Microsoft.Exchange.Management.PowerShell.SnapIn;
$Style = "
<style>
    BODY{background-color:#FFFFFF;}
    TABLE{border-width: 1px;border-style: solid;border-color: black;border-collapse: collapse;}
    TH{border-width: 1px;padding: 3px;border-style: solid;border-color: black;background-color:#778899}
    TD{border-width: 1px;padding: 3px;border-style: solid;border-color: black;}
    tr:nth-child(odd) { background-color:#d3d3d3;} 
    tr:nth-child(even) { background-color:white;}    
</style>
"

$server = Get-ExchangeServer

ForEach ($servers in $server){

$Date = Get-Date -Format d

$path = "C:\Temp\ExchangeServicesReport.html"
$StatusColor = @{Stopped = ' bgcolor="Red">Stopped<';Automatic = ' bgcolor="cyan">Automatic<';Manual = ' bgcolor="#85C1E9">Manual<';UNKNOWN = ' bgcolor="#EC7063">UNKNOWN<';Running = ' bgcolor="#52BE80">Running<';}
$GService = Get-Service -ComputerName $servers | where {$_.Name -like "MSEx*"} | select @{N='Exchange';E={$Servers}}, Name,Status,StartType | ConvertTo-HTML -AS Table -Fragment -PreContent '<h2>Exchange Dienste Status</h2>'| Out-String 
$StatusColor.Keys | foreach { $GService = $GService -replace ">$_<",($StatusColor.$_) }

$CStatusColor = @{Inactive = ' bgcolor="Red">Inactive<';Draining = ' bgcolor="cyan">Draining<';UNKNOWN = ' bgcolor="#EC7063">UNKNOWN<';Active = ' bgcolor="#52BE80">Active<';}
$CStatusService = Get-ServerComponentState -Identity $servers | select @{N='Exchange';E={$Servers}}, Component,State | ConvertTo-HTML -AS Table -Fragment -PreContent '<h2>Exchange Komponenten Status</h2>'| Out-String 
$CStatusColor.Keys | foreach { $CStatusService = $CStatusService -replace ">$_<",($CStatusColor.$_) }

$Reboots = Get-WinEvent -FilterHashtable @{logname='system';id=6005} -MaxEvents 8 | Select Message, TimeCreated | ConvertTo-HTML -AS Table -Fragment -PreContent '<h2>Die letzten 8 Reboots</h2>'| Out-String

ConvertTo-HTML -head $Style -PostContent $GService, $CStatusService, $Reboots | Out-File $path

$subject = "Exchange Services Report $servers - " + $date
$body = Get-Content $path -raw
$attach = $Path
$smtpServer = "SRVEX"
$emailFrom = "jw@dwp.local"
$emailTo = "mail@joernwalter.de"

Send-MailMessage -To $emailTo -Subject $subject -Body $body -Attachments $attach -SmtpServer $smtpServer -From $emailFrom -BodyAsHtml
}